{{- $any_cluster_enabled := false -}}
{{- range .Values.createRules -}}
  {{- if . -}}
    {{- $any_cluster_enabled = true -}}
  {{- end }}
{{- end }}

{{- $clusters_list := list }}
{{- $rule_file_list := list }}
{{- $optional_rules_disabled := list }}

{{- range $unit := .Values.optional_rules }}
  {{- if not $unit.enabled }}
    {{- range $file := $unit.files }}
      {{- $optional_rules_disabled  = append $optional_rules_disabled $file }}
    {{- end }}
  {{- end }}
{{- end }}

{{- if $any_cluster_enabled }}
apiVersion: v1
kind: List
items:
    {{- range $cluster, $true := (omit .Values.createRules "allclusters") -}}
      {{- if and $true $cluster }} 
        {{- $clusters_list = append $clusters_list $cluster }}
      {{- end }}
    {{- end }}

    {{- if .Values.createRules.allclusters }}
      {{- $clusters_list = append $clusters_list "allclusters" }}
    {{- end }}

    {{- range $cluster := $clusters_list -}}
      {{- if $cluster -}}
        {{- $cluster_path := printf "%s/%s/%s" "alert-rules" $cluster "*.yaml" -}}
        {{- range $path, $bytes := $.Files.Glob $cluster_path }}
        {{- $prometheus_rule_name := $path | base | trimSuffix ".yaml" }}
        {{- if and (not (has $prometheus_rule_name $rule_file_list)) (not (has $prometheus_rule_name $optional_rules_disabled)) }}
          {{ $rule_file_list = append $rule_file_list $prometheus_rule_name }}
  - apiVersion: "monitoring.coreos.com/v1"
    kind: PrometheusRule
    metadata:
      name: {{ $prometheus_rule_name }}
    spec:
          {{- $.Files.Get $path | nindent 6 }}
        {{- end -}}
      {{- end -}}
    {{- end -}}
  {{- end }}
{{- end -}}
